=== libs/librepcb/editor/CMakeLists.txt ===
# Enable Qt MOC/UIC/RCC
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTOUIC ON)
set(CMAKE_AUTORCC OFF)

# Export library
add_library(
  librepcb_editor STATIC
  3d/openglobject.h
  3d/openglscenebuilder.cpp
  3d/openglscenebuilder.h
  3d/opengltriangleobject.cpp
  3d/opengltriangleobject.h
  cmd/cmdattributeedit.cpp
  cmd/cmdattributeedit.h
  cmd/cmdcircleedit.cpp
  cmd/cmdcircleedit.h
  cmd/cmdholeedit.cpp
  cmd/cmdholeedit.h
  cmd/cmdlistelementinsert.h
  cmd/cmdlistelementremove.h
  cmd/cmdlistelementsswap.h
  cmd/cmdpolygonedit.cpp
  cmd/cmdpolygonedit.h
  cmd/cmdstroketextedit.cpp
  cmd/cmdstroketextedit.h
  cmd/cmdtextedit.cpp
  cmd/cmdtextedit.h
  cmd/cmdzoneedit.cpp
  cmd/cmdzoneedit.h
  dialogs/aboutdialog.cpp
  dialogs/aboutdialog.h
  dialogs/aboutdialog.ui
  dialogs/circlepropertiesdialog.cpp
  dialogs/circlepropertiesdialog.h
  dialogs/circlepropertiesdialog.ui
  dialogs/directorylockhandlerdialog.cpp
  dialogs/directorylockhandlerdialog.h
  dialogs/directorylockhandlerdialog.ui
  dialogs/dxfimportdialog.cpp
  dialogs/dxfimportdialog.h
  dialogs/dxfimportdialog.ui
  dialogs/filedialog.cpp
  dialogs/filedialog.h
  dialogs/graphicsexportdialog.cpp
  dialogs/graphicsexportdialog.h
  dialogs/graphicsexportdialog.ui
  dialogs/gridsettingsdialog.cpp
  dialogs/gridsettingsdialog.h
  dialogs/gridsettingsdialog.ui
  dialogs/holepropertiesdialog.cpp
  dialogs/holepropertiesdialog.h
  dialogs/holepropertiesdialog.ui
  dialogs/polygonpropertiesdialog.cpp
  dialogs/polygonpropertiesdialog.h
  dialogs/polygonpropertiesdialog.ui
  dialogs/stroketextpropertiesdialog.cpp
  dialogs/stroketextpropertiesdialog.h
  dialogs/stroketextpropertiesdialog.ui
  dialogs/textpropertiesdialog.cpp
  dialogs/textpropertiesdialog.h
  dialogs/textpropertiesdialog.ui
  dialogs/zonepropertiesdialog.cpp
  dialogs/zonepropertiesdialog.h
  dialogs/zonepropertiesdialog.ui
  editorcommand.cpp
  editorcommand.h
  editorcommandcategory.h
  editorcommandset.h
  graphics/circlegraphicsitem.cpp
  graphics/circlegraphicsitem.h
  graphics/defaultgraphicslayerprovider.cpp
  graphics/defaultgraphicslayerprovider.h
  graphics/graphicslayer.cpp
  graphics/graphicslayer.h
  graphics/graphicsscene.cpp
  graphics/graphicsscene.h
  graphics/holegraphicsitem.cpp
  graphics/holegraphicsitem.h
  graphics/linegraphicsitem.cpp
  graphics/linegraphicsitem.h
  graphics/origincrossgraphicsitem.cpp
  graphics/origincrossgraphicsitem.h
  graphics/polygongraphicsitem.cpp
  graphics/polygongraphicsitem.h
  graphics/primitivecirclegraphicsitem.cpp
  graphics/primitivecirclegraphicsitem.h
  graphics/primitivefootprintpadgraphicsitem.cpp
  graphics/primitivefootprintpadgraphicsitem.h
  graphics/primitiveholegraphicsitem.cpp
  graphics/primitiveholegraphicsitem.h
  graphics/primitivepathgraphicsitem.cpp
  graphics/primitivepathgraphicsitem.h
  graphics/primitivetextgraphicsitem.cpp
  graphics/primitivetextgraphicsitem.h
  graphics/primitivezonegraphicsitem.cpp
  graphics/primitivezonegraphicsitem.h
  graphics/stroketextgraphicsitem.cpp
  graphics/stroketextgraphicsitem.h
  graphics/textgraphicsitem.cpp
  graphics/textgraphicsitem.h
  graphics/zonegraphicsitem.cpp
  graphics/zonegraphicsitem.h
  library/cat/categorychooserdialog.cpp
  library/cat/categorychooserdialog.h
  library/cat/categorychooserdialog.ui
  library/cat/categorylisteditorwidget.cpp
  library/cat/categorylisteditorwidget.h
  library/cat/categorylisteditorwidget.ui
  library/cat/categorytreebuilder.cpp
  library/cat/categorytreebuilder.h
  library/cat/categorytreelabeltextbuilder.cpp
  library/cat/categorytreelabeltextbuilder.h
  library/cat/componentcategoryeditorwidget.cpp
  library/cat/componentcategoryeditorwidget.h
  library/cat/componentcategoryeditorwidget.ui
  library/cat/packagecategoryeditorwidget.cpp
  library/cat/packagecategoryeditorwidget.h
  library/cat/packagecategoryeditorwidget.ui
  library/cmd/cmdcomponentedit.cpp
  library/cmd/cmdcomponentedit.h
  library/cmd/cmdcomponentpinsignalmapitemedit.cpp
  library/cmd/cmdcomponentpinsignalmapitemedit.h
  library/cmd/cmdcomponentsignaledit.cpp
  library/cmd/cmdcomponentsignaledit.h
  library/cmd/cmdcomponentsymbolvariantedit.cpp
  library/cmd/cmdcomponentsymbolvariantedit.h
  library/cmd/cmdcomponentsymbolvariantitemedit.cpp
  library/cmd/cmdcomponentsymbolvariantitemedit.h
  library/cmd/cmddeviceedit.cpp
  library/cmd/cmddeviceedit.h
  library/cmd/cmddevicepadsignalmapitemedit.cpp
  library/cmd/cmddevicepadsignalmapitemedit.h
  library/cmd/cmddragselectedfootprintitems.cpp
  library/cmd/cmddragselectedfootprintitems.h
  library/cmd/cmddragselectedsymbolitems.cpp
  library/cmd/cmddragselectedsymbolitems.h
  library/cmd/cmdfootprintedit.cpp
  library/cmd/cmdfootprintedit.h
  library/cmd/cmdfootprintpadedit.cpp
  library/cmd/cmdfootprintpadedit.h
  library/cmd/cmdlibrarybaseelementedit.cpp
  library/cmd/cmdlibrarybaseelementedit.h
  library/cmd/cmdlibrarycategoryedit.cpp
  library/cmd/cmdlibrarycategoryedit.h
  library/cmd/cmdlibraryedit.cpp
  library/cmd/cmdlibraryedit.h
  library/cmd/cmdlibraryelementedit.cpp
  library/cmd/cmdlibraryelementedit.h
  library/cmd/cmdpackageedit.cpp
  library/cmd/cmdpackageedit.h
  library/cmd/cmdpackagemodeladd.cpp
  library/cmd/cmdpackagemodeladd.h
  library/cmd/cmdpackagemodeledit.cpp
  library/cmd/cmdpackagemodeledit.h
  library/cmd/cmdpackagemodelremove.cpp
  library/cmd/cmdpackagemodelremove.h
  library/cmd/cmdpackagepadedit.cpp
  library/cmd/cmdpackagepadedit.h
  library/cmd/cmdpartedit.cpp
  library/cmd/cmdpartedit.h
  library/cmd/cmdpastefootprintitems.cpp
  library/cmd/cmdpastefootprintitems.h
  library/cmd/cmdpastesymbolitems.cpp
  library/cmd/cmdpastesymbolitems.h
  library/cmd/cmdremoveselectedfootprintitems.cpp
  library/cmd/cmdremoveselectedfootprintitems.h
  library/cmd/cmdremoveselectedsymbolitems.cpp
  library/cmd/cmdremoveselectedsymbolitems.h
  library/cmd/cmdsymbolpinedit.cpp
  library/cmd/cmdsymbolpinedit.h
  library/cmp/cmpsigpindisplaytypecombobox.cpp
  library/cmp/cmpsigpindisplaytypecombobox.h
  library/cmp/componentchooserdialog.cpp
  library/cmp/componentchooserdialog.h
  library/cmp/componentchooserdialog.ui
  library/cmp/componenteditorwidget.cpp
  library/cmp/componenteditorwidget.h
  library/cmp/componenteditorwidget.ui
  library/cmp/componentpinsignalmapmodel.cpp
  library/cmp/componentpinsignalmapmodel.h
  library/cmp/componentsignallisteditorwidget.cpp
  library/cmp/componentsignallisteditorwidget.h
  library/cmp/componentsignallistmodel.cpp
  library/cmp/componentsignallistmodel.h
  library/cmp/componentsymbolvarianteditdialog.cpp
  library/cmp/componentsymbolvarianteditdialog.h
  library/cmp/componentsymbolvarianteditdialog.ui
  library/cmp/componentsymbolvariantitemlisteditorwidget.cpp
  library/cmp/componentsymbolvariantitemlisteditorwidget.h
  library/cmp/componentsymbolvariantitemlistmodel.cpp
  library/cmp/componentsymbolvariantitemlistmodel.h
  library/cmp/componentsymbolvariantlistmodel.cpp
  library/cmp/componentsymbolvariantlistmodel.h
  library/cmp/componentsymbolvariantlistwidget.cpp
  library/cmp/componentsymbolvariantlistwidget.h
  library/cmp/compsymbvarpinsignalmapeditorwidget.cpp
  library/cmp/compsymbvarpinsignalmapeditorwidget.h
  library/cmp/if_componentsymbolvarianteditorprovider.h
  library/dev/deviceeditorwidget.cpp
  library/dev/deviceeditorwidget.h
  library/dev/deviceeditorwidget.ui
  library/dev/devicepadsignalmapmodel.cpp
  library/dev/devicepadsignalmapmodel.h
  library/dev/padsignalmapeditorwidget.cpp
  library/dev/padsignalmapeditorwidget.h
  library/dev/partlisteditorwidget.cpp
  library/dev/partlisteditorwidget.h
  library/dev/partlistmodel.cpp
  library/dev/partlistmodel.h
  library/eaglelibraryimportwizard/eaglelibraryimportwizard.cpp
  library/eaglelibraryimportwizard/eaglelibraryimportwizard.h
  library/eaglelibraryimportwizard/eaglelibraryimportwizard.ui
  library/eaglelibraryimportwizard/eaglelibraryimportwizardcontext.cpp
  library/eaglelibraryimportwizard/eaglelibraryimportwizardcontext.h
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_chooselibrary.cpp
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_chooselibrary.h
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_chooselibrary.ui
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_result.cpp
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_result.h
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_result.ui
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_selectelements.cpp
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_selectelements.h
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_selectelements.ui
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_setoptions.cpp
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_setoptions.h
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_setoptions.ui
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_start.cpp
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_start.h
  library/eaglelibraryimportwizard/eaglelibraryimportwizardpage_start.ui
  library/editorwidgetbase.cpp
  library/editorwidgetbase.h
  library/lib/librarylisteditorwidget.cpp
  library/lib/librarylisteditorwidget.h
  library/lib/librarylisteditorwidget.ui
  library/lib/libraryoverviewwidget.cpp
  library/lib/libraryoverviewwidget.h
  library/lib/libraryoverviewwidget.ui
  library/libraryeditor.cpp
  library/libraryeditor.h
  library/libraryeditor.ui
  library/libraryelementcache.cpp
  library/libraryelementcache.h
  library/newelementwizard/newelementwizard.cpp
  library/newelementwizard/newelementwizard.h
  library/newelementwizard/newelementwizard.ui
  library/newelementwizard/newelementwizardcontext.cpp
  library/newelementwizard/newelementwizardcontext.h
  library/newelementwizard/newelementwizardpage_choosetype.cpp
  library/newelementwizard/newelementwizardpage_choosetype.h
  library/newelementwizard/newelementwizardpage_choosetype.ui
  library/newelementwizard/newelementwizardpage_componentpinsignalmap.cpp
  library/newelementwizard/newelementwizardpage_componentpinsignalmap.h
  library/newelementwizard/newelementwizardpage_componentpinsignalmap.ui
  library/newelementwizard/newelementwizardpage_componentproperties.cpp
  library/newelementwizard/newelementwizardpage_componentproperties.h
  library/newelementwizard/newelementwizardpage_componentproperties.ui
  library/newelementwizard/newelementwizardpage_componentsignals.cpp
  library/newelementwizard/newelementwizardpage_componentsignals.h
  library/newelementwizard/newelementwizardpage_componentsignals.ui
  library/newelementwizard/newelementwizardpage_componentsymbols.cpp
  library/newelementwizard/newelementwizardpage_componentsymbols.h
  library/newelementwizard/newelementwizardpage_componentsymbols.ui
  library/newelementwizard/newelementwizardpage_copyfrom.cpp
  library/newelementwizard/newelementwizardpage_copyfrom.h
  library/newelementwizard/newelementwizardpage_copyfrom.ui
  library/newelementwizard/newelementwizardpage_deviceproperties.cpp
  library/newelementwizard/newelementwizardpage_deviceproperties.h
  library/newelementwizard/newelementwizardpage_deviceproperties.ui
  library/newelementwizard/newelementwizardpage_entermetadata.cpp
  library/newelementwizard/newelementwizardpage_entermetadata.h
  library/newelementwizard/newelementwizardpage_entermetadata.ui
  library/newelementwizard/newelementwizardpage_packagepads.cpp
  library/newelementwizard/newelementwizardpage_packagepads.h
  library/newelementwizard/newelementwizardpage_packagepads.ui
  library/pkg/boardsideselectorwidget.cpp
  library/pkg/boardsideselectorwidget.h
  library/pkg/footprintclipboarddata.cpp
  library/pkg/footprintclipboarddata.h
  library/pkg/footprintgraphicsitem.cpp
  library/pkg/footprintgraphicsitem.h
  library/pkg/footprintlisteditorwidget.cpp
  library/pkg/footprintlisteditorwidget.h
