=== debian/changelog ===
librepcb (1.1.0+dfsg-1) unstable; urgency=medium

  * New upstream release

 -- Federico Ceratto <federico@debian.org>  Wed, 12 Jun 2024 16:52:26 +0200

librepcb (1.0.0-2) unstable; urgency=medium

  * Initial release (Closes: #950328)

 -- Federico Ceratto <federico@debian.org>  Wed, 07 Feb 2024 17:05:41 +0100

librepcb (1.0.0-1) unstable; urgency=medium

  * New upstream release

 -- Federico Ceratto <federico@debian.org>  Tue, 06 Feb 2024 23:24:33 +0100

librepcb (0.1.7-1) unstable; urgency=medium

  * New upstream release

 -- Federico Ceratto <federico@debian.org>  Sat, 03 Dec 2022 13:16:01 +0000

librepcb (0.1.6-1) UNRELEASED; urgency=medium

  * New upstream release

 -- Federico Ceratto <federico@debian.org>  Sun, 28 Nov 2021 19:04:04 +0000

librepcb (0.1.4+dfsg-1) UNRELEASED; urgency=medium

  * Initial packaging

 -- Federico Ceratto <federico@debian.org>  Sun, 26 Jul 2020 20:41:19 +0100
