=== debian/control ===
Source: librepcb
Section: electronics
Priority: optional
Maintainer: Debian Electronics Team <pkg-electronics-devel@alioth-lists.debian.net>
Uploaders: Federico Ceratto <federico@debian.org>
Build-Depends: debhelper-compat (= 13),
 cmake,
 debhelper,
 fonts-noto-core,
 libglu1-mesa-dev,
 libocct-data-exchange-dev,
 libocct-draw-dev,
 libocct-foundation-dev,
 libocct-modeling-algorithms-dev,
 libocct-modeling-data-dev,
 libocct-ocaf-dev,
 libocct-visualization-dev,
 libqt5opengl5-dev,
 libqt5opengl5-dev,
 libqt5svg5-dev,
 libquazip5-dev,
 libquazip1-qt5-dev,
 libsfml-dev,
 libtbb-dev,
 openssl,
 qtbase5-dev,
 qtchooser,
 qtdeclarative5-dev,
 qtquickcontrols2-5-dev,
 qttools5-dev,
 qttools5-dev-tools,
 zlib1g,
 zlib1g-dev
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: https://librepcb.org
Vcs-Browser: https://salsa.debian.org/debian/librepcb
Vcs-Git: https://salsa.debian.org/debian/librepcb.git

Package: librepcb
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 fonts-noto-core,
Description: EDA software to develop printed circuit boards
 Provides project management, powerful library management,
 and intuitive schematic and board editors.
 Human-readable, VCS-friendly file formats for libraries and projects.
 Supports multiple PCB variants for the same schematic and
 automatic netlist synchronisation between schematic and board.
