## librepcb 1.2.0%2Bdfsg

=== debian/control ===
--- 
+++ 
@@ -15,20 +15,15 @@
  libocct-modeling-data-dev,
  libocct-ocaf-dev,
  libocct-visualization-dev,
- libqt5opengl5-dev,
- libqt5opengl5-dev,
- libqt5svg5-dev,
- libquazip5-dev,
- libquazip1-qt5-dev,
- libsfml-dev,
+ libquazip1-qt6-dev,
  libtbb-dev,
  openssl,
- qtbase5-dev,
+ qt6-base-dev,
+ qt6-declarative-dev,
+ qt6-svg-dev,
+ qt6-tools-dev,
+ qt6-tools-dev-tools,
  qtchooser,
- qtdeclarative5-dev,
- qtquickcontrols2-5-dev,
- qttools5-dev,
- qttools5-dev-tools,
  zlib1g,
  zlib1g-dev
 Standards-Version: 4.6.2
